{******************************************************************************}
{   unit/Unit XButtons                                                        }
{                                                                              }
{   Sorry for my very bad english :-)                                          }
{                                                                              }
{ TXStaticButton :                                                             }
{   Un peu identique  TSpeedButton except qu'il ne possde pas les           }
{   proprits Caption, Layout et Spacing. Il ne dessine pas de contour.       }
{   Il affiche le bitmap charg dans sa proprit Glyph, ou si cette proprit }
{   est vide, il devient une zone transparente active  placer au dessus       }
{   d'un Bitmap pour dfinir plusieurs zones cliquables par exemple.           }
{   Si la proprit HotTrack est  true, le bitmap de la proprit Glyph doit  }
{   reprsenter 3 tats : normal/off, dsactiv/disabled et hot/on et la       }
{   proprit NumGlyphs doit tre positionne  3.                             }
{   Si un PopupMenu est associ au contrle, il peut tre activ avec le       }
{   bouton gauche ou droit de la souris, et tre affich  la position du clic }
{   de la souris (par dfaut) ou aux 4 coins du contrle grace  la proprit  }
{   PopupLocation.                                                             }
{   Il possde trois venements en plus que TSpeedButton : OnMouseEnter,       }
{   OnMouseExit et OnPaint.                                                    }
{                                                                              }
{   A little identical to TSpeedButton except which it doesn't have the        }
{   Caption, Layout and Spacing properties. It doesn't draw edge. It display   }
{   the bitmap charged in its Glyph property, or if this property  is empty,   }
{   it becomes an active transparent zone to place at the top of Bitmap to     }
{   define several hot zones for example.                                      }
{   If the HotTrack property is set to true, the bitmap must represent 3       }
{   states:  off, disabled and on and the NumGlyphs property must be set to 3. }
{   If PopupMenu is associated with control, it can be activated with the      }
{   left or right mouse button, and can be displayed at the position of the    }
{   mouse clic (by default) or at the 4 corners of control with the            }
{   PopupLocation property.                                                    }
{   It has three events in more than TSpeedButton:  OnMouseEnter, OnMouseExit  }
{   and OnPaint.                                                               }
{                                                                              }
{                                                                              }
{ TXFoldButton :                                                               }
{   Identique  TXStaticButton mais avec la possibilit de se dplier et se    }
{   replier sur lui mme en ajustant la taille du contrle parent              }
{   (gnralement un TPanel). Lorsque le bouton est repli il est possible de  }
{   cacher les contrles du parent et lorsqu'il est dpli de les afficher.    }
{   Deux proprits, GlyphFolded et GlyphUnFolded sont utilises pour afficher }
{   l'tat pli/dpli.                                                        }
{                                                                              }
{   Identical to TXStatiBUTTON but with the possibility of unfolding itself    }
{   and to fold up itself on him even by adjusting the size of his parent      }
{   control (generally TPanel). When the button is folded up it's possible to  }
{   hide the Parent controls and when it's unfolded to display them.           }
{   Two properties, GlyphFolded and GlyphUnFolded are used to display the      }
{   folded/unfolded state.                                                     }
{                                                                              }
{   Proprits/Properties :                                                    }
{     - ChangeParentSize: boolean                                              }
{         Change ou non la taille du parent.                                   }
{         Change or not the parent size.                                       }
{     - FoldType: TFoldType                                                    }
{         ftHeight change sa hauteur et celle de son parent, sans modifier la  }
{         largeur.                                                             }
{         ftWidth change sa largeur et celle de son parent, sans modifier la   }
{         hauteur.                                                             }
{         ftHeight changes its height and that of his parent, without          }
{         modifying the width.                                                 }
{         ftWidth changes its width and that of his parent, without modifying  }
{         the height.                                                          }
{     - GlyphFolded: TBitmap                                                   }
{         Bitmap reprsentant le bouton repli.                                }
{         Bitmap representing the folded up button.                            }
{     - GlyphUnFolded: TBitmap                                                 }
{         Bitmap reprsentant le bouton dpli.                                }
{         Bitmap representing the unfolded button.                             }
{     - HideParentControl: boolean                                             }
{         Si True, Cache les contrles enfants de son parent.                  }
{         If True, Hides children controls of its parent.                      }
{     - RemainingSize: integer                                                 }
{         Taille ajoute au contrle dpli (1 pixel par dfaut).              }
{         Size added to unfolded control (1 pixel by default).                 }
{     - UseUnFolded: boolean                                                   }
{         A False, ne dplie pas le bouton.                                    }
{         If False, the button does not unfold.                                }
{   Evenements :                                                               }
{     - OnFolded                                                               }
{         Se produit une fois le bouton repli et aprs la taille du parent    }
{         ajuste et ses contrles cachs.                                     }
{         Occurs once the button folded up and after the size of his parent    }
{         is adjusted and its controls hidden.                                 }
{     - OnUnFolded                                                             }
{         Se produit une fois le bouton dpli et aprs la taille du parent    }
{         ajuste et ses contrles affichs.                                   }
{         Occurs once the button unfolded and after the size of is parent is   }
{         adjusted and its controls displayed.                                 }
{     - OnHideParentControls                                                   }
{         Se produit avant que les contrles du parent soit cachs et permet   }
{         grace  la variable CanHide d'empcher qu'un contrle particulier    }
{         soit cach.                                                          }
{         Occurs before the parent controls is hidden and allows with the      }
{         CanHide var of prevent that a particular control is hidden.          }
{     - OnShowParentControls                                                   }
{         Identique  OnHideParentControls mais se produit quand les contrles }
{         enfants du parent vont tre raffichs.                              }
{         Identical to OnHideParentControls but occurs when the children       }
{         controls of his parent will be displayed.                            }
{     - OnResizeParent                                                         }
{         Se produit avant que la taille du parent soit modifie. Permet  ce  }
{         moment de modifier la valeur de RemainingSize.                       }
{         Occurs before the size of is parent is modified.  Allows to modify   }
{         the RemainingSize value.                                             }
{                                                                              }
{                                                                              }
{  COPYRIGHT / GARANTIE                                                        }
{                                                                              }
{ Ces composants sont des gratuiciel et donc libre de droits. Il sont fournis  }
{ TEL QUEL, sans aucune garantie expresse ou tacite, pour quelque raison       }
{ que ce soit, y compris d'ventuels dommages causs par l'utilisation de ces  }
{ composants, les dommages pour pertes de profits, cessation d'activites       }
{ commerciales ou autre.                                                       }
{ Vous pouvez utiliser ces composants comme bon vous semble, except pour une  }
{ utilisation commerciale, c'est  dire ne pas utiliser tout ou  partie de ces }
{ composants dans un projet commercial (Dans ce cas le paiement d'une modeste  }
{ licence vous sera demand - contactez moi pour les prcisions).              }
{ Vous ne pouvez pas prtendre avoir crit ces composants et vous n'tes pas   }
{ autoris  supprimer l'en-tte du fichier source (question d'thique).       }
{ Si vous n'tes pas en accord avec ce qui prcde, ne les utilisez pas.       }
{                                                                              }
{ Donc, si vous modifiez ou amliorez ces composants, laissez intacte l'en-tte}
{ de ce fichier et ajoutez vos commentaires  la fin de cet l'en-tte.         }
{ Tous commentaires et/ou suggestions, rapport de bug, seront apprcis.       }
{ Si vous l'utilisez dans un projet, merci de mentionner mon nom et mon        }
{ adresse e-mail.                                                              }
{                                                                              }
{  COPYRIGHT/ LIMITED WARRANTY                                                 }
{                                                                              }
{  THESE COMPONENTS ARE FREEWARE AND PROVIDED 'AS IS' WITHOUT WARRANTIES OF ANY}
{  KIND, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED }
{  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.         }
{  THE AUTHOR DOESN'T ASSUME ANY RESPONSIBILITY FOR ANY DAMAGE OR ANY LOOSE OF }
{  TIME OR MONEY DUE THE USE OF ANY PART OF THESE COMPONENTS. THE AUTHOR SHALL }
{  NOT BE LIABLE FOR INCIDENTAL, CONSEQUENTIAL, LOSS OF BUSINESS PROFITS OR    }
{  SPECIAL OR INDIRECT DAMAGES OF ANY SORT, WHETHER ARISING IN TORT, CONTRACT  }
{  OR OTHERWISE, EVEN IF THE AUTHOR HAS BEEN INFORMED OF THE POSSIBILITY OF    }
{  SUCH DAMAGES.                                                               }
{                                                                              }
{  THE AUTHOR ARE SURE YOU KNOW THAT A NULL-COST FREE SOFTWARE DOES NOT        }
{  PROVIDE ANY WARRANTIES.                                                     }
{  IF YOU DON'T AGREE THIS TERMS, DON'T USE THESE COMPONENTS.                  }
{                                                                              }
{  You can use these components as you want, EXCEPT FOR A COMMERCIAL USE (what }
{  obliges the payment of a weak licence).                                     }
{  You cannot claim to have written these components and you are NOT authorized}
{  to remove the heading of source file (ethics problem).                      }
{                                                                              }
{  If you modify the source or make corrections or additions, add simply your  }
{  comments, a description and your name at the end of heading. In that case   }
{  thank you to send me a copy of your modifications.                          }
{                                                                              }
{  You can send me an e-mail with a bugs list, a request for modification or   }
{  development of new functionalities.                                         }
{  Generally, all comments or suggestions will be appreciated. Please, tell me }
{  what you do with this component, or simply Hello, I like your components.   }
{  If you use it in a project, thank's to mention my name and my               }
{  e-mail addresses.                                                           }
{                                                                              }
{ Auteur/Author : Jean-Michel BOUCTON                                          }
{ email : jmbo@softhome.net                                                    }
{                                                                              }
{------------------------------------------------------------------------------}
{ Auteur/Author : Jean-Michel BOUCTON                                          }
{ Version : 1.0.0                                                              }
{ Cration/Creation : 18/04/1999                                               }
{                                                                              }
{ Cration de TXStaticButton.                                                  }
{------------------------------------------------------------------------------}
{ Auteur/Author : Jean-Michel BOUCTON                                          }
{ Version : 1.1.0                                                              }
{ Date : 19/04/1999                                                            }
{                                                                              }
{ Cration de TXFoldButton.                                                    }
{------------------------------------------------------------------------------}
{ Auteur/Author : Jean-Michel BOUCTON                                          }
{ Version : 1.2.0                                                              }
{ Date : 23/04/1999                                                            }
{                                                                              }
{ - Suppression des proprits Align, Font, Color, ParentColor, ParentFont.    }
{   Ajout des proprit Transparent et FoldState qui permet de choisir l'tat  }
{   pli/dpli  la conception o par code.                                   }
{   BUG : sous Delphi 2 en mode transparent, le blanc est aussi masqu ???     }
{ - Suppression of Align, Font, Color, ParentColor, ParentFont properties.     }
{   Add new properties Transparent and FoldState, which allow to select the    }
{   state foloded/unfolded at design time or by code.                          }
{   BUG : under Delphi 2 in transparent mode, white color is masked too,       }
{   why ???                                                                    }
{------------------------------------------------------------------------------}
{ Auteur/Author :                                                              }
{ Version :                                                                    }
{ Date :                                                                       }
{                                                                              }
{******************************************************************************}
unit XButtons;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, CommCtrl, Menus;

type

  TStaticButtonState = (sbsOff, sbsDisabled, sbsOn);
  TNumGlyphs = 1..4;
  TPopupMouseButton = (pmbLeft, pmbRight);
  TPopupLocation = (plDefault, plTopLeft, plTopRight, plBottomLeft, plBottomRight);

  TXControl = class(TControl)
  public
    property PopupMenu;  // Pour la visibilit de GetPopupMenu de l'anctre
  end;

  TXStaticButton = class(TGraphicControl)
  private
    FOnPaint: TNotifyEvent;
    FGlyph: Pointer;
    FPopupLocation: TPopupLocation;
    FOnMouseEnter: TNotifyEvent;
    FOnMouseExit: TNotifyEvent;
    FHotTrack: Boolean;
    FPopupMouseButton: TPopupMouseButton;
    FTransparent: Boolean;
    procedure GlyphChanged(Sender: TObject);
    procedure SetHotTrack(Value: Boolean);
    function GetGlyph: TBitmap;
    procedure SetGlyph(Value: TBitmap);
    function GetNumGlyphs: TNumGlyphs;
    procedure SetNumGlyphs(Value: TNumGlyphs);
    procedure CheckMenuPopup(const Pos: TSmallPoint);
    procedure SetPopoupCoord(var Message: TWMMouse);
    procedure DoEnter; dynamic;
    procedure DoExit; dynamic;
    procedure CMEnabledChanged(var Message: TMessage); message CM_ENABLEDCHANGED;
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure DoMouseUp(var Message: TWMMouse; Button: TMouseButton);
    procedure WMLButtonUp(var Message: TWMLButtonUp); message WM_LBUTTONUP;
    procedure WMRButtonUp(var Message: TWMRButtonUp); message WM_RBUTTONUP;
  protected
    FState: TStaticButtonState;
    procedure Loaded; override;
    procedure Paint; override;
    function GetTransparent: Boolean; virtual;
    procedure SetTransparent(Value: Boolean); virtual;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Click; override;
    property Canvas;
  published
    property DragCursor;
    property DragMode;
    property Enabled;
    property HotTrack: Boolean read FHotTrack write SetHotTrack default False;
    property Font;
    property Glyph: TBitmap read GetGlyph write SetGlyph;
    property NumGlyphs: TNumGlyphs read GetNumGlyphs write SetNumGlyphs default 1;
    property ParentShowHint;
    property PopupMouseButton: TPopupMouseButton read FPopupMouseButton write FPopupMouseButton default pmbRight;
    property PopupLocation: TPopupLocation read  FPopupLocation write FPopupLocation;
    property PopupMenu;
    property ShowHint;
    property Transparent: Boolean read GetTransparent write SetTransparent default true;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnMouseEnter: TNotifyEvent read FOnMouseEnter write FOnMouseEnter;
    property OnMouseExit: TNotifyEvent read FOnMouseExit write FOnMouseExit;
    property OnPaint: TNotifyEvent read FOnPaint write FOnPaint;
  end;

{ TXFoldButton }

  TFoldType = (ftHeight, ftWidth);
  TFoldState = (fsFolded, fsUnFolded);
  TResizeParentEvent = procedure(Sender: TObject; var RemainingSize: integer) of object;
  THideParentControlsEvent = procedure(Sender: TObject; Control: TControl; var CanHide: boolean) of object;
  TShowParentControlsEvent = procedure(Sender: TObject; Control: TControl; var CanShow: boolean) of object;

  TXFoldButton = class(TGraphicControl)
  private
    FOnPaint: TNotifyEvent;
    FGlyph: Pointer;
    FGlyphFolded: Pointer;
    FGlyphUnFolded: Pointer;
    FParentControl: TWinControl;
    FFolded : boolean;
    FFoldState: TFoldState;
    FUseUnFolded : boolean;
    FHideParentControls : boolean;
    FChangeParentSize: boolean;
    FFoldType: TFoldType;
    FRemainingSize : integer;
    FDefaultSize : integer;
    FPopupLocation: TPopupLocation;
    FOnMouseEnter: TNotifyEvent;
    FOnMouseExit: TNotifyEvent;
    FHotTrack: Boolean;
    FPopupMouseButton: TPopupMouseButton;
    FTransparent: Boolean;
    FOnFolded: TNotifyEvent;
    FOnUnFolded: TNotifyEvent;
    FOnResizeParent: TResizeParentEvent;
    FOnHideParentControls: THideParentControlsEvent;
    FOnShowParentControls: TShowParentControlsEvent;
    procedure GlyphChanged(Sender: TObject);
    procedure SetUseUnFolded(Value: Boolean);
    procedure SetHideParentControls(Value: Boolean);
    procedure SetChangeParentSize(Value: Boolean);
    procedure SetFoldType(Value: TFoldType);
    procedure SetRemainingSize(Value: integer);
    procedure SetHotTrack(Value: Boolean);
    function GetGlyphFolded: TBitmap;
    procedure SetGlyphUnFolded(Value: TBitmap);
    function GetGlyphUnFolded: TBitmap;
    procedure SetGlyphFolded(Value: TBitmap);
    function GetNumGlyphs: TNumGlyphs;
    procedure SetNumGlyphs(Value: TNumGlyphs);
    procedure CheckMenuPopup(const Pos: TSmallPoint);
    procedure SetPopoupCoord(var Message: TWMMouse);
    procedure SetFoldState(Value: TFoldState);
    procedure DoEnter; dynamic;
    procedure DoExit; dynamic;
    procedure CMEnabledChanged(var Message: TMessage); message CM_ENABLEDCHANGED;
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure DoMouseUp(var Message: TWMMouse; Button: TMouseButton);
    procedure WMLButtonUp(var Message: TWMLButtonUp); message WM_LBUTTONUP;
    procedure WMRButtonUp(var Message: TWMRButtonUp); message WM_RBUTTONUP;
  protected
    FState: TStaticButtonState;
    procedure Loaded; override;
    procedure Paint; override;
    procedure SetFold; virtual;
    procedure SetParentSize; virtual;
    procedure SetParentControls; virtual;
    function GetTransparent: Boolean; virtual;
    procedure SetTransparent(Value: Boolean); virtual;
    property Folded : boolean read FFolded;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Click; override;
    property Canvas;
  published
    property DragCursor;
    property DragMode;
    property Enabled;
    property FoldState: TFoldState read FFoldState write SetFoldState;
    property FoldType: TFoldType read FFoldType write SetFoldType;
    property RemainingSize: integer read FRemainingSize write SetRemainingSize default 1;
    property HideParentControls: boolean read FHideParentControls write SetHideParentControls;
    property ChangeParentSize: boolean read FChangeParentSize write SetChangeParentSize;
    property HotTrack: Boolean read FHotTrack write SetHotTrack default False;
    property GlyphFolded: TBitmap read GetGlyphFolded write SetGlyphFolded;
    property GlyphUnFolded: TBitmap read GetGlyphUnFolded write SetGlyphUnFolded;
    property NumGlyphs: TNumGlyphs read GetNumGlyphs write SetNumGlyphs default 1;
    property ParentShowHint;
    property PopupMouseButton: TPopupMouseButton read FPopupMouseButton write FPopupMouseButton default pmbRight;
    property PopupLocation: TPopupLocation read  FPopupLocation write FPopupLocation;
    property PopupMenu;
    property ShowHint;
    property Transparent: Boolean read GetTransparent write SetTransparent default true;
    property UseUnFolded : boolean read FUseUnFolded write SetUseUnFolded default false;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnMouseEnter: TNotifyEvent read FOnMouseEnter write FOnMouseEnter;
    property OnMouseExit: TNotifyEvent read FOnMouseExit write FOnMouseExit;
    property OnPaint: TNotifyEvent read FOnPaint write FOnPaint;
    property OnFolded: TNotifyEvent read FOnFolded write FOnFolded;
    property OnUnFolded: TNotifyEvent read FOnUnFolded write FOnUnFolded;
    property OnResizeParent: TResizeParentEvent read FOnResizeParent write FOnResizeParent;
    property OnHideParentControls: THideParentControlsEvent read FOnHideParentControls write FOnHideParentControls;
    property OnShowParentControls: TShowParentControlsEvent read FOnShowParentControls write FOnShowParentControls;
  end;

implementation

uses Consts;


type
  TGlyphList = class(TImageList)
  private
    Used: TBits;
    FCount: Integer;
    function AllocateIndex: Integer;
  public
    constructor CreateSize(AWidth, AHeight: Integer);
    destructor Destroy; override;
{$IFDEF VER90}
    function Add(Image, Mask: TBitmap): Integer;
{$ENDIF}
    function AddMasked(Image: TBitmap; MaskColor: TColor): Integer;
    procedure Delete(Index: Integer);
    property Count: Integer read FCount;
  end;

  TGlyphCache = class
  private
    GlyphLists: TList;
  public
    constructor Create;
    destructor Destroy; override;
    function GetList(AWidth, AHeight: Integer): TGlyphList;
    procedure ReturnList(List: TGlyphList);
    function Empty: Boolean;
  end;

  TButtonGlyph = class
  private
    FOriginal: TBitmap;
    FGlyphList: TGlyphList;
    FIndexs: array[TStaticButtonState] of Integer;
    FTransparentColor: TColor;
    FBkgColor: TColor;
    FNumGlyphs: TNumGlyphs;
    FOnChange: TNotifyEvent;
    procedure GlyphChanged(Sender: TObject);
    procedure SetGlyph(Value: TBitmap);
    procedure SetNumGlyphs(Value: TNumGlyphs);
    procedure Invalidate;
    function CreateButtonGlyph(State: TStaticButtonState; Transparent: Boolean): Integer;
    procedure DrawButtonGlyph(Canvas: TCanvas; const GlyphPos: TPoint;
      State: TStaticButtonState; Transparent: Boolean);
  public
    constructor Create;
    destructor Destroy; override;
    function Draw(Canvas: TCanvas; State: TStaticButtonState; Transparent: Boolean): TRect;
    property Glyph: TBitmap read FOriginal write SetGlyph;
    property NumGlyphs: TNumGlyphs read FNumGlyphs write SetNumGlyphs;
    property BkgColor: TColor read FBkgColor write FBkgColor;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
  end;

{ TGlyphList }

constructor TGlyphList.CreateSize(AWidth, AHeight: Integer);
begin
  inherited CreateSize(AWidth, AHeight);
  Used := TBits.Create;
end;

destructor TGlyphList.Destroy;
begin
  Used.Free;
  inherited Destroy;
end;

function TGlyphList.AllocateIndex: Integer;
begin
  Result := Used.OpenBit;
  if Result >= Used.Size then
  begin
    Result := inherited Add(nil, nil);
    Used.Size := Result + 1;
  end;
  Used[Result] := True;
end;
{$IFDEF VER90}
function TGlyphList.Add(Image, Mask: TBitmap): Integer;
begin
  Result := AllocateIndex;
  Replace(Result, Image, Mask);
  Inc(FCount);
end;
{$ENDIF}
function TGlyphList.AddMasked(Image: TBitmap; MaskColor: TColor): Integer;
begin
  Result := AllocateIndex;
  ReplaceMasked(Result, Image, MaskColor);
  Inc(FCount);
end;

procedure TGlyphList.Delete(Index: Integer);
begin
  if Used[Index] then
  begin
    Dec(FCount);
    Used[Index] := False;
  end;
end;

{ TGlyphCache }

constructor TGlyphCache.Create;
begin
  inherited Create;
  GlyphLists := TList.Create;
end;

destructor TGlyphCache.Destroy;
begin
  GlyphLists.Free;
  inherited Destroy;
end;

function TGlyphCache.GetList(AWidth, AHeight: Integer): TGlyphList;
var
  I: Integer;
begin
  for I := GlyphLists.Count - 1 downto 0 do
  begin
    Result := GlyphLists[I];
    with Result do
      if (AWidth = Width) and (AHeight = Height) then Exit;
  end;
  Result := TGlyphList.CreateSize(AWidth, AHeight);
  GlyphLists.Add(Result);
end;

procedure TGlyphCache.ReturnList(List: TGlyphList);
begin
  if List = nil then Exit;
  if List.Count = 0 then
  begin
    GlyphLists.Remove(List);
    List.Free;
  end;
end;

function TGlyphCache.Empty: Boolean;
begin
  Result := GlyphLists.Count = 0;
end;

var
  GlyphCache: TGlyphCache = nil;
  Pattern: TBitmap = nil;
  ButtonCount: Integer = 0;

{ TButtonGlyph }

constructor TButtonGlyph.Create;
var
  I: TStaticButtonState;
begin
  inherited Create;
  FOriginal := TBitmap.Create;
  FOriginal.OnChange := GlyphChanged;
  FTransparentColor := clOlive;
  BkgColor := clBtnFace;
  FNumGlyphs := 1;
  for I := Low(I) to High(I) do
    FIndexs[I] := -1;
  if GlyphCache = nil then GlyphCache := TGlyphCache.Create;
end;

destructor TButtonGlyph.Destroy;
begin
  FOriginal.Free;
  Invalidate;
  if Assigned(GlyphCache) and GlyphCache.Empty then
  begin
    GlyphCache.Free;
    GlyphCache := nil;
  end;
  inherited Destroy;
end;

procedure TButtonGlyph.Invalidate;
var
  I: TStaticButtonState;
begin
  for I := Low(I) to High(I) do
  begin
    if FIndexs[I] <> -1 then FGlyphList.Delete(FIndexs[I]);
    FIndexs[I] := -1;
  end;
  GlyphCache.ReturnList(FGlyphList);
  FGlyphList := nil;
end;

procedure TButtonGlyph.GlyphChanged(Sender: TObject);
begin
  if Sender = FOriginal then
  begin
    FTransparentColor := FOriginal.TransparentColor;
    Invalidate;
    if Assigned(FOnChange) then FOnChange(Self);
  end;
end;

procedure TButtonGlyph.SetGlyph(Value: TBitmap);
var
  Glyphs: Integer;
begin
  Invalidate;
  FOriginal.Assign(Value);
  if (Value <> nil) and (Value.Height > 0) then
  begin
    FTransparentColor := Value.TransparentColor;
    if Value.Width mod Value.Height = 0 then
    begin
      Glyphs := Value.Width div Value.Height;
      if Glyphs > 4 then Glyphs := 1;
      SetNumGlyphs(Glyphs);
    end;
  end;
end;

procedure TButtonGlyph.SetNumGlyphs(Value: TNumGlyphs);
begin
  if (Value <> FNumGlyphs) and (Value > 0) then
  begin
    Invalidate;
    FNumGlyphs := Value;
    GlyphChanged(Glyph);
  end;
end;

function TButtonGlyph.CreateButtonGlyph(State: TStaticButtonState; Transparent: Boolean): Integer;
const
  ROP_DSPDxax = $00E20746;
var
  TmpImage, DDB, MonoBmp: TBitmap;
  IWidth, IHeight: Integer;
  IRect, ORect: TRect;
  I: TStaticButtonState;
  DestDC: HDC;
begin
  if (State = sbsOn) and (NumGlyphs < 3) then State := sbsOff;
  Result := FIndexs[State];
  if Result <> -1 then Exit;
  if (FOriginal.Width or FOriginal.Height) = 0 then Exit;
  IWidth := FOriginal.Width div FNumGlyphs;
  IHeight := FOriginal.Height;
  if FGlyphList = nil then
  begin
    if GlyphCache = nil then GlyphCache := TGlyphCache.Create;
    FGlyphList := GlyphCache.GetList(IWidth, IHeight);
  end;
  TmpImage := TBitmap.Create;
  try
    TmpImage.Width := IWidth;
    TmpImage.Height := IHeight;
    IRect := Rect(0, 0, IWidth, IHeight);
{$IFDEF VER90}
    if Transparent then
    begin
      TmpImage.Canvas.Brush.Color := FTransparentColor;
    end else
      TmpImage.Canvas.Brush.Color := clBtnFace;
{$ELSE}
    TmpImage.Canvas.Brush.Color := clBtnFace;
    TmpImage.Palette := CopyPalette(FOriginal.Palette);
{$ENDIF}
    I := State;
    if Ord(I) >= NumGlyphs then I := sbsOff;
    ORect := Rect(Ord(I) * IWidth, 0, (Ord(I) + 1) * IWidth, IHeight);
    case State of
      sbsOff, sbson :
      begin
{$IFDEF VER90}
        TmpImage.Canvas.BrushCopy(IRect, FOriginal, ORect, FTransparentColor);
        if Transparent then    // AddMasked masque aussi le blanc, pouquoi ???
                               // AddMasked mask the white too, why ???
          FIndexs[State] := FGlyphList.AddMasked(TmpImage, FTransparentColor)
        else
          FIndexs[State] := FGlyphList.Add(TmpImage, nil);
{$ELSE}
        TmpImage.Canvas.CopyRect(IRect, FOriginal.Canvas, ORect);
        if FOriginal.TransparentMode = tmFixed then
          FIndexs[State] := FGlyphList.AddMasked(TmpImage, FTransparentColor)
        else
          FIndexs[State] := FGlyphList.AddMasked(TmpImage, clDefault);
{$ENDIF}
      end;
      sbsDisabled:
      begin
        MonoBmp := nil;
        DDB := nil;
        try
          MonoBmp := TBitmap.Create;
{$IFNDEF VER90}
          DDB := TBitmap.Create;
          DDB.Assign(FOriginal);
          DDB.HandleType := bmDDB;
{$ENDIF}
          if NumGlyphs > 1 then
          with TmpImage.Canvas do
          begin    { Change white & gray to clBtnHighlight and clBtnShadow }
{$IFNDEF VER90}
            CopyRect(IRect, DDB.Canvas, ORect);
{$ELSE}
            CopyRect(IRect, FOriginal.Canvas, ORect);
{$ENDIF}
            MonoBmp.Monochrome := True;
            MonoBmp.Width := IWidth;
            MonoBmp.Height := IHeight;

            { Convert white to clBtnHighlight }
{$IFNDEF VER90}
            DDB.Canvas.Brush.Color := clWhite;
            MonoBmp.Canvas.CopyRect(IRect, DDB.Canvas, ORect);
{$ELSE}
            FOriginal.Canvas.Brush.Color := clWhite;
            MonoBmp.Canvas.CopyRect(IRect, FOriginal.Canvas, ORect);
{$ENDIF}
            Brush.Color := clBtnHighlight;
            DestDC := Handle;
            SetTextColor(DestDC, clBlack);
            SetBkColor(DestDC, clWhite);
            BitBlt(DestDC, 0, 0, IWidth, IHeight,
                   MonoBmp.Canvas.Handle, 0, 0, ROP_DSPDxax);

            { Convert gray to clBtnShadow }
{$IFNDEF VER90}
            DDB.Canvas.Brush.Color := clGray;
            MonoBmp.Canvas.CopyRect(IRect, DDB.Canvas, ORect);
{$ELSE}
              FOriginal.Canvas.Brush.Color := clGray;
              MonoBmp.Canvas.CopyRect(IRect, FOriginal.Canvas, ORect);
{$ENDIF}
            Brush.Color := clBtnShadow;
            DestDC := Handle;
            SetTextColor(DestDC, clBlack);
            SetBkColor(DestDC, clWhite);
            BitBlt(DestDC, 0, 0, IWidth, IHeight,
                   MonoBmp.Canvas.Handle, 0, 0, ROP_DSPDxax);

            { Convert transparent color to clBtnFace }
{$IFNDEF VER90}
            DDB.Canvas.Brush.Color := ColorToRGB(FTransparentColor);
            MonoBmp.Canvas.CopyRect(IRect, DDB.Canvas, ORect);
{$ELSE}
            FOriginal.Canvas.Brush.Color := ColorToRGB(FTransparentColor);
            MonoBmp.Canvas.CopyRect(IRect, FOriginal.Canvas, ORect);
{$ENDIF}
            Brush.Color := clBtnFace;
            DestDC := Handle;
            SetTextColor(DestDC, clBlack);
            SetBkColor(DestDC, clWhite);
            BitBlt(DestDC, 0, 0, IWidth, IHeight,
                   MonoBmp.Canvas.Handle, 0, 0, ROP_DSPDxax);
          end
          else
          begin
            { Create a disabled version }
            with MonoBmp do
            begin
              Assign(FOriginal);
{$IFNDEF VER90}
              HandleType := bmDDB;
{$ENDIF}
              Canvas.Brush.Color := clBlack;
              Width := IWidth;
              if Monochrome then
              begin
                Canvas.Font.Color := clWhite;
                Monochrome := False;
                Canvas.Brush.Color := clWhite;
              end;
              Monochrome := True;
            end;
            with TmpImage.Canvas do
            begin
              Brush.Color := clBtnFace;
              FillRect(IRect);
              Brush.Color := clBtnHighlight;
              SetTextColor(Handle, clBlack);
              SetBkColor(Handle, clWhite);
              BitBlt(Handle, 1, 1, IWidth, IHeight,
                MonoBmp.Canvas.Handle, 0, 0, ROP_DSPDxax);
              Brush.Color := clBtnShadow;
              SetTextColor(Handle, clBlack);
              SetBkColor(Handle, clWhite);
              BitBlt(Handle, 0, 0, IWidth, IHeight,
                MonoBmp.Canvas.Handle, 0, 0, ROP_DSPDxax);
            end;
          end;
        finally
          DDB.Free;
          MonoBmp.Free;
        end;
{$IFDEF VER90}
        if Transparent then
          FIndexs[State] := FGlyphList.AddMasked(TmpImage, FTransparentColor)
        else
          FIndexs[State] := FGlyphList.Add(TmpImage, nil);
{$ELSE}
        FIndexs[State] := FGlyphList.AddMasked(TmpImage, clDefault);
{$ENDIF}
      end;
    end;
  finally
    TmpImage.Free;
  end;
  Result := FIndexs[State];
  FOriginal.Dormant;
end;

procedure TButtonGlyph.DrawButtonGlyph(Canvas: TCanvas; const GlyphPos: TPoint;
  State: TStaticButtonState; Transparent: Boolean);
var
  Index: Integer;
begin
  if FOriginal = nil then Exit;
  if (FOriginal.Width = 0) or (FOriginal.Height = 0) then Exit;
  Index := CreateButtonGlyph(State, Transparent);
  with GlyphPos do
    if Transparent then
      ImageList_DrawEx(FGlyphList.Handle, Index, Canvas.Handle, X, Y, 0, 0,
        clNone, clNone, ILD_Transparent)
    else
      ImageList_DrawEx(FGlyphList.Handle, Index, Canvas.Handle, X, Y, 0, 0,
        ColorToRGB(clBtnFace), clNone, ILD_Normal);
end;

function TButtonGlyph.Draw(Canvas: TCanvas; State: TStaticButtonState; Transparent: Boolean): TRect;
var
  GlyphPos: TPoint;
begin
  GlyphPos.x := 0;
  GlyphPos.y := 0;
  DrawButtonGlyph(Canvas, GlyphPos, State, Transparent);
end;

{ TXStaticButton }

constructor TXStaticButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := ControlStyle + [csReplicatable];
  FTransparent := true;
  FGlyph := TButtonGlyph.Create;
  TButtonGlyph(FGlyph).OnChange := GlyphChanged;
  Left := 0;
  Height := 25;
  Top := 1;
  Width := 40;
  FPopupMouseButton := pmbRight;
end;

destructor TXStaticButton.Destroy;
begin
  TButtonGlyph(FGlyph).Free;
  Dec(ButtonCount);
  if ButtonCount = 0 then
  begin
    Pattern.Free;
    Pattern := nil;
  end;
  inherited Destroy;
end;

procedure TXStaticButton.Loaded;
var
  State: TStaticButtonState;
begin
  inherited Loaded;
  if Enabled then
    State := sbsOff
  else
    State := sbsDisabled;
  TButtonGlyph(FGlyph).CreateButtonGlyph(State, FTransparent);
end;

procedure TXStaticButton.Paint;
begin
  if not Enabled then
    FState := sbsDisabled
  else if FState = sbsDisabled then
    FState := sbsOff;
  Canvas.Font := Font;
  Canvas.Brush.Color := Color;
  if csDesigning in ComponentState then
    with Canvas do
    begin
      Pen.Style := psDash;
      Brush.Style := bsClear;
      Rectangle(0, 0, Width, Height);
    end;
  TButtonGlyph(FGlyph).Draw(Canvas, FState, FTransparent);
  if Assigned(FOnPaint) then FOnPaint(Self);
end;

procedure TXStaticButton.DoEnter;
begin
  FState := sbsOn;
  if Assigned(FOnMouseEnter) then FOnMouseEnter(Self);
end;

procedure TXStaticButton.DoExit;
begin
  FState := sbsOff;
  if Assigned(FOnMouseExit) then FOnMouseExit(Self);
end;

procedure TXStaticButton.CMEnabledChanged(var Message: TMessage);
begin
  Repaint;
end;

procedure TXStaticButton.CMMouseEnter(var Message: TMessage);
begin
  inherited;
  if FHotTrack and Enabled then
  begin
    DoEnter;
    Repaint;
  end;
end;

procedure TXStaticButton.CMMouseLeave(var Message: TMessage);
begin
  inherited;
  if FHotTrack and Enabled then
  begin
    DoExit;
    Invalidate;
  end;
end;

procedure TXStaticButton.SetHotTrack(Value: Boolean);
begin
  if Value <> FHotTrack then
  begin
    FHotTrack := Value;
    Invalidate;
  end;
end;

function TXStaticButton.GetGlyph: TBitmap;
begin
  Result := TButtonGlyph(FGlyph).Glyph;
end;

procedure TXStaticButton.SetGlyph(Value: TBitmap);
begin
  TButtonGlyph(FGlyph).Glyph := Value;
  Invalidate;
end;

function TXStaticButton.GetNumGlyphs: TNumGlyphs;
begin
  Result := TButtonGlyph(FGlyph).NumGlyphs;
end;

procedure TXStaticButton.SetNumGlyphs(Value: TNumGlyphs);
begin
  if Value < 0 then Value := 1
  else if Value > 4 then Value := 4;
  if (Value <> TButtonGlyph(FGlyph).NumGlyphs) then
  begin
    TButtonGlyph(FGlyph).NumGlyphs := Value;
    Invalidate;
  end;
end;

procedure TXStaticButton.CheckMenuPopup(const Pos: TSmallPoint);
var
  Control: TXControl;
  oPopupMenu: TPopupMenu;
begin
  if csDesigning in ComponentState then Exit;
  Control := TXControl(Self);
  while Control <> nil do
  begin
    oPopupMenu := Control.GetPopupMenu;
    if (oPopupMenu <> nil) and oPopupMenu.AutoPopup then
    begin
      SendCancelMode(nil);
      oPopupMenu.PopupComponent := Control;
      with ClientToScreen(SmallPointToPoint(Pos)) do
        oPopupMenu.Popup(X, Y);
      Exit;
    end;
    Control := TXControl(Control.Parent);
  end;
end;

function TXStaticButton.GetTransparent: Boolean;
begin
  Result := FTransparent;
end;

procedure TXStaticButton.SetTransparent(Value: Boolean);
begin
  if Value <> FTransparent then
  begin
    FTransparent := Value;
{$IFNDEF VER90}
    TButtonGlyph(FGlyph).Glyph.Transparent := Value;
{$ENDIF}
    Invalidate;
  end;
end;

procedure TXStaticButton.DoMouseUp(var Message: TWMMouse; Button: TMouseButton);
begin
  with Message do
    inherited MouseUp(Button, KeysToShiftState(Keys), XPos, YPos);
end;

procedure TXStaticButton.SetPopoupCoord(var Message: TWMMouse);
begin
  with Message.Pos do
    case FPopupLocation of
      plDefault : exit;
      plTopLeft :
      begin
        X := 0;
        Y := 0;
      end;
      plTopRight :
      begin
        X := Self.Width;
        Y := 0;
      end;
      plBottomLeft :
      begin
        X := 0;
        Y := Self.Height;
      end;
      plBottomRight :
      begin
        X := Self.Width;
        Y := Self.Height;
      end;
    end;
end;

procedure TXStaticButton.WMLButtonUp(var Message: TWMLButtonUp);
begin
  inherited;
  if (FPopupMouseButton = pmbLeft) and (Message.Result = 0) then
  begin
    SetPopoupCoord(Message);
    CheckMenuPopup(Message.Pos);
    FState := sbsOff;
  end;
  Repaint;
end;

procedure TXStaticButton.WMRButtonUp(var Message: TWMRButtonUp);
begin
  DoMouseUp(Message, mbRight);
  if (FPopupMouseButton = pmbRight) and (Message.Result = 0) then
  begin
    SetPopoupCoord(Message);
    CheckMenuPopup(Message.Pos);
    FState := sbsOff;
    Repaint;
  end;
end;

procedure TXStaticButton.GlyphChanged(Sender: TObject);
begin
  Invalidate;
end;

procedure TXStaticButton.Click;
begin
  inherited Click;
end;


{ TXFoldButton }

constructor TXFoldButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
    FParentControl := nil;
  ControlStyle := ControlStyle + [csReplicatable];
  FTransparent := true;
  FGlyphFolded := TButtonGlyph.Create;
  TButtonGlyph(FGlyphFolded).OnChange := GlyphChanged;
  FGlyphUnFolded := TButtonGlyph.Create;
  TButtonGlyph(FGlyphUnFolded).OnChange := GlyphChanged;
  FGlyph := FGlyphFolded;
  FFolded := true;
  FFoldState := fsFolded;
  Left := 0;
  Height := 26;
  Top := 1;
  Width := 26;
  FDefaultSize := 40;
  FRemainingSize := 1;
  FPopupMouseButton := pmbRight;
end;

destructor TXFoldButton.Destroy;
begin
  TButtonGlyph(FGlyphFolded).Free;
  TButtonGlyph(FGlyphunFolded).Free;
  Dec(ButtonCount);
  if ButtonCount = 0 then
  begin
    Pattern.Free;
    Pattern := nil;
  end;
  inherited Destroy;
end;

procedure TXFoldButton.Loaded;
var
  State: TStaticButtonState;
begin
  inherited Loaded;
  if Self.Enabled then
    State := sbsOff
  else
    State := sbsDisabled;
  TButtonGlyph(FGlyphFolded).CreateButtonGlyph(State, FTransparent);
  TButtonGlyph(FGlyphunFolded).CreateButtonGlyph(State, FTransparent);
  if (FoldState = fsUnFolded) and UseUnFolded then
  begin
    FGlyph := FGlyphUnFolded;
    SetFold;
  end else
    FGlyph := FGlyphFolded;
end;

procedure TXFoldButton.Paint;
begin
  if not Enabled then
    FState := sbsDisabled
  else if FState = sbsDisabled then
    FState := sbsOff;
  Canvas.Font := Font;
  Canvas.Brush.Color := Color;
  if csDesigning in ComponentState then
    with Canvas do
    begin
      Pen.Style := psDash;
      Brush.Style := bsClear;
      Rectangle(0, 0, Width, Height);
    end;
  // FGlyph pointe sur le glyph en cours, folded ou UnFolded
  TButtonGlyph(FGlyph).Draw(Canvas, FState, FTransparent);
  if Assigned(FOnPaint) then FOnPaint(Self);
end;

procedure TXFoldButton.DoEnter;
begin
  FState := sbsOn;
  if Assigned(FOnMouseEnter) then FOnMouseEnter(Self);
end;

procedure TXFoldButton.DoExit;
begin
  FState := sbsOff;
  if Assigned(FOnMouseExit) then FOnMouseExit(Self);
end;

procedure TXFoldButton.CMEnabledChanged(var Message: TMessage);
begin
  Repaint;
end;

procedure TXFoldButton.CMMouseEnter(var Message: TMessage);
begin
  inherited;
  if FHotTrack and Enabled then
  begin
    DoEnter;
    Repaint;
  end;
end;

procedure TXFoldButton.CMMouseLeave(var Message: TMessage);
begin
  inherited;
  if FHotTrack and Enabled then
  begin
    DoExit;
    Invalidate;
  end;
end;

procedure TXFoldButton.SetUseUnFolded(Value: Boolean);
begin
  if not Value and (FFoldState = fsUnFolded) then
  begin
    SetFoldState(fsFolded);
  end;
  FUseUnFolded := Value;
end;

procedure TXFoldButton.SetRemainingSize(Value: integer);
begin
  if Value <> FRemainingSize then
  begin
    FRemainingSize := Value;
  end;
end;

procedure TXFoldButton.SetHideParentControls(Value: Boolean);
begin
  if Value <> FHideParentControls then
  begin
    FHideParentControls := Value;
    SetParentControls;
  end;
end;

procedure TXFoldButton.SetChangeParentSize(Value: Boolean);
begin
  if Value <> FChangeParentSize then
  begin
    FChangeParentSize := Value;
  end;
end;

procedure TXFoldButton.SetFoldType(Value: TFoldType);
begin
  if Value <> FFoldType then
  begin
    FFoldType := Value;
  end;
end;

procedure TXFoldButton.SetHotTrack(Value: Boolean);
begin
  if Value <> FHotTrack then
  begin
    FHotTrack := Value;
    Invalidate;
  end;
end;

function TXFoldButton.GetGlyphFolded: TBitmap;
begin
  Result := TButtonGlyph(FGlyphFolded).Glyph;
end;

procedure TXFoldButton.SetGlyphFolded(Value: TBitmap);
begin
  TButtonGlyph(FGlyphFolded).Glyph := Value;
  Invalidate;
end;

function TXFoldButton.GetGlyphUnFolded: TBitmap;
begin
  Result := TButtonGlyph(FGlyphUnFolded).Glyph;
end;

procedure TXFoldButton.SetGlyphUnFolded(Value: TBitmap);
begin
  TButtonGlyph(FGlyphUnFolded).Glyph := Value;
  Invalidate;
end;

function TXFoldButton.GetNumGlyphs: TNumGlyphs;
begin
  Result := TButtonGlyph(FGlyph).NumGlyphs;
end;

procedure TXFoldButton.SetNumGlyphs(Value: TNumGlyphs);
begin
  if Value < 0 then Value := 1
  else if Value > 4 then Value := 4;
  if (Value <> TButtonGlyph(FGlyphFolded).NumGlyphs) or
     (Value <> TButtonGlyph(FGlyphUnFolded).NumGlyphs)then
  begin
    TButtonGlyph(FGlyphFolded).NumGlyphs := Value;
    TButtonGlyph(FGlyphUnFolded).NumGlyphs := Value;
    Invalidate;
  end;
end;

function TXFoldButton.GetTransparent: Boolean;
begin
  Result := FTransparent;
end;

procedure TXFoldButton.SetTransparent(Value: Boolean);
begin
  if Value <> FTransparent then
  begin
    FTransparent := Value;
{$IFNDEF VER90}
    TButtonGlyph(FGlyphFolded).Glyph.Transparent := Value;
    TButtonGlyph(FGlyphUnFolded).Glyph.Transparent := Value;
{$ENDIF}
    Invalidate;
  end;
end;

procedure TXFoldButton.CheckMenuPopup(const Pos: TSmallPoint);
var
  Control: TXControl;
  oPopupMenu: TPopupMenu;
begin
  if csDesigning in ComponentState then Exit;
  Control := TXControl(Self);
  while Control <> nil do
  begin
    oPopupMenu := Control.GetPopupMenu;
    if (oPopupMenu <> nil) and oPopupMenu.AutoPopup then
    begin
      SendCancelMode(nil);
      oPopupMenu.PopupComponent := Control;
      with ClientToScreen(SmallPointToPoint(Pos)) do
        oPopupMenu.Popup(X, Y);
      Exit;
    end;
    Control := TXControl(Control.Parent);
  end;
end;

procedure TXFoldButton.DoMouseUp(var Message: TWMMouse; Button: TMouseButton);
begin
  with Message do
    inherited MouseUp(Button, KeysToShiftState(Keys), XPos, YPos);
end;

procedure TXFoldButton.SetPopoupCoord(var Message: TWMMouse);
begin
  with Message.Pos do
    case FPopupLocation of
      plDefault : exit;
      plTopLeft :
      begin
        X := 0;
        Y := 0;
      end;
      plTopRight :
      begin
        X := Self.Width;
        Y := 0;
      end;
      plBottomLeft :
      begin
        X := 0;
        Y := Self.Height;
      end;
      plBottomRight :
      begin
        X := Self.Width;
        Y := Self.Height;
      end;
    end;
end;

procedure TXFoldButton.SetFoldState(Value: TFoldState);
begin
  if not (csLoading in ComponentState) then
    if (Value = fsUnFolded) and (not FUseUnFolded) then exit;
  FFoldState := Value;
  if FUseUnFolded then
  begin
    if Value = fsUnFolded then
      FFolded := true
    else
      FFolded := false;
    SetFold;
  end;
end;

procedure TXFoldButton.SetParentControls;
var
  i: integer;
  Control: TControl;
  lCanHide, lCanShow: boolean;
begin
  if (FParentControl = nil) then
    FParentControl := Parent;
  if (FParentControl <> nil) then
  begin
    // Si le bouton est repli, cacher les contrles
    if FFolded and FHideParentControls then
    begin
      for i := 0 to FParentControl.ControlCount - 1 do
      begin
        Control := FParentControl.Controls[i];
        if Control = Self then
          continue;
        lCanHide := true;
        if assigned(FOnHideParentControls) then
          FOnHideParentControls(Self, Control, lCanHide);
        Control.Visible := not lCanHide;
      end;
    end else    // Si le bouton est dpli, afficher les contrles
    begin
      for i := 0 to FParentControl.ControlCount - 1 do
      begin
        Control := FParentControl.Controls[i];
        if Control = Self then
          continue;
        lCanShow := true;
        if assigned(FOnShowParentControls) then
          FOnShowParentControls(Self, Control, lCanShow);
        Control.Visible := lCanShow;
      end;
    end;
  end;
end;

procedure TXFoldButton.SetParentSize;
begin
  if (FParentControl = nil) then
    FParentControl := Parent;
  if (FParentControl <> nil) and FChangeParentSize then
  begin
    if assigned(FOnResizeParent) then FOnResizeParent(Self, FRemainingSize);
    if FFoldType = ftHeight then
      FParentControl.Height := (FParentControl.Height - FParentControl.ClientHeight) + Top + Height + FRemainingSize
    else
      FParentControl.Width := (FParentControl.Width - FParentControl.ClientWidth) + Left + Width + FRemainingSize;
  end;
end;

procedure TXFoldButton.SetFold;
begin
  if FUseUnFolded then
  begin
    if FFolded then    // Si le contrle est repli
    begin
      FGlyph := FGlyphUnFolded;
      if TButtonGlyph(FGlyphUnFolded).Glyph.Height > 0 then
        Height := TButtonGlyph(FGlyphUnFolded).Glyph.Height;
      if TButtonGlyph(FGlyphUnFolded).Glyph.Width > 0 then
        Width := TButtonGlyph(FGlyphUnFolded).Glyph.Width div NumGlyphs;
      FFolded := false;       // Le contrle est dpli
      SetParentControls;
      SetParentSize;
      if Assigned(FOnUnFolded) then FOnUnFolded(Self);
    end else
    begin
      FGlyph := FGlyphFolded;
      if TButtonGlyph(FGlyphUnFolded).Glyph.Height > 0 then
        Height := TButtonGlyph(FGlyphFolded).Glyph.Height;
      if TButtonGlyph(FGlyphUnFolded).Glyph.Width > 0 then
        Width := TButtonGlyph(FGlyphFolded).Glyph.Width div NumGlyphs;
      FFolded := true;       // Le contrle est repli
      SetParentControls;
      SetParentSize;
      if Assigned(FOnFolded) then FOnFolded(Self);
    end;
    Repaint;
  end;
end;

procedure TXFoldButton.WMLButtonUp(var Message: TWMLButtonUp);
begin
  inherited;
  if FFolded then
    FoldState := fsUnFolded
  else
    FoldState := fsFolded;
  if (FPopupMouseButton = pmbLeft) and (Message.Result = 0) then
  begin
    SetPopoupCoord(Message);
    CheckMenuPopup(Message.Pos);
    FState := sbsOff;
  end;
  Repaint;
end;

procedure TXFoldButton.WMRButtonUp(var Message: TWMRButtonUp);
begin
  DoMouseUp(Message, mbRight);
  if (FPopupMouseButton = pmbRight) and (Message.Result = 0) then
  begin
    SetPopoupCoord(Message);
    CheckMenuPopup(Message.Pos);
    FState := sbsOff;
    Repaint;
  end;
end;

procedure TXFoldButton.GlyphChanged(Sender: TObject);
begin
  Invalidate;
end;

procedure TXFoldButton.Click;
begin
  inherited Click;
end;

end.
