unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, XButtons, Buttons, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    XStaticButton1: TXStaticButton;
    CheckBox1: TCheckBox;
    Panel2: TPanel;
    SpeedButton1: TSpeedButton;
    Label2: TLabel;
    XFoldButton1: TXFoldButton;
    SpeedButton3: TSpeedButton;
    PopupMnuOptResult: TPopupMenu;
    miClearResult: TMenuItem;
    miLoadResult: TMenuItem;
    miSaveResult: TMenuItem;
    N5: TMenuItem;
    midisplayAllMessages: TMenuItem;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    XFoldButton3: TXFoldButton;
    Label3: TLabel;
    Label4: TLabel;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Edit1: TEdit;
    UpDown1: TUpDown;
    Label5: TLabel;
    CheckBox5: TCheckBox;
    Label6: TLabel;
    CheckBox6: TCheckBox;
    procedure CheckBox1Click(Sender: TObject);
    procedure XFoldButton1HideParentControls(Sender: TObject;
      Control: TControl; var CanHide: Boolean);
    procedure UpDown1Changing(Sender: TObject; var AllowChange: Boolean);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit1Change(Sender: TObject);
    procedure XFoldButton3UnFolded(Sender: TObject);
    procedure XFoldButton3Folded(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure XFoldButton1Folded(Sender: TObject);
    procedure XFoldButton1UnFolded(Sender: TObject);
    procedure XFoldButton3MouseEnter(Sender: TObject);
    procedure XFoldButton3MouseExit(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  XFoldButton1.Enabled := CheckBox1.Checked;
end;

// Utilisez l'vnement OnHideParentControls pour tester un contrle particulier
// Use the OnHideParentControls event to test a particular control
procedure TForm1.XFoldButton1HideParentControls(Sender: TObject;
  Control: TControl; var CanHide: Boolean);
begin
  if Control.Name = 'Label2' then
    CanHide := not CheckBox2.Checked;
end;

procedure TForm1.UpDown1Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
  XFoldButton3.RemainingSize := UpDown1.Position;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if not(Key in ['0'..'9']) then
    Key := #0;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  XFoldButton3.RemainingSize := StrToInt(Edit1.Text);
end;

procedure TForm1.XFoldButton3UnFolded(Sender: TObject);
begin
  if CheckBox4.Checked then
    GroupBox1.Caption := '';
end;

procedure TForm1.XFoldButton3Folded(Sender: TObject);
begin
  if GroupBox1.Caption = '' then
    GroupBox1.Caption := 'GroupBox';
end;

procedure TForm1.CheckBox5Click(Sender: TObject);
begin
  XFoldButton1.HideParentControls := CheckBox5.Checked;
end;

// Dmontre l'utilisation de l'vnement OnFolded
// Show the use of the OnFolded event
procedure TForm1.XFoldButton1Folded(Sender: TObject);
begin
  XFoldButton1.Hint := 'I''m Folded';
end;

procedure TForm1.XFoldButton1UnFolded(Sender: TObject);
begin
  XFoldButton1.Hint := 'I''m UnFolded';
end;

// Dmontre l'utilisation de l'vnement OnMouseEnter
// Show the use of the OnMouseEnter event
procedure TForm1.XFoldButton3MouseEnter(Sender: TObject);
begin
  Label6.Caption := 'Enter XFoldButton3';
end;

procedure TForm1.XFoldButton3MouseExit(Sender: TObject);
begin
  Label6.Caption := '';
end;

procedure TForm1.CheckBox6Click(Sender: TObject);
begin
  if CheckBox6.Checked then
    XFoldButton1.FoldState := fsFolded
  else
    XFoldButton1.FoldState := fsUnFolded;
end;

end.
